'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Styling = require('./Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var _FormRow = require('./Form/Row');

var _FormRow2 = _interopRequireDefault(_FormRow);

var _Label = require('./Label');

var _Label2 = _interopRequireDefault(_Label);

var _FormRowWrapper = require('./Form/RowWrapper');

var _FormRowWrapper2 = _interopRequireDefault(_FormRowWrapper);

var styles = {
  osx_10_11: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    display: 'flex',
    flexDirection: 'column',
    alignItems: 'center',

    label: {
      marginBottom: '20px'
    }
  }
};

var Form = (function (_Component) {
  _inherits(Form, _Component);

  _createClass(Form, null, [{
    key: 'Row',
    value: _FormRow2['default'],
    enumerable: true
  }, {
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      onSubmit: _react.PropTypes.func,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function Form(props) {
    var _this = this;

    _classCallCheck(this, Form);

    _get(Object.getPrototypeOf(Form.prototype), 'constructor', this).call(this);
    this.labels = [];
    this.rows = [];

    this.submit = function (event) {
      event.preventDefault();
      if (_this.props.onSubmit) {
        _this.props.onSubmit();
      }
    };

    this.state = { visible: props.visible !== false, display: props.display !== false };
  }

  _createClass(Form, [{
    key: 'registerRow',
    value: function registerRow(row) {
      this.rows = [].concat(_toConsumableArray(this.rows), [row]);
    }
  }, {
    key: 'registerLabel',
    value: function registerLabel(label) {
      this.labels = [].concat(_toConsumableArray(this.labels), [label]);
      this.applyWithToLabels();
      this.applyWithToRows();
    }
  }, {
    key: 'applyWithToLabels',
    value: function applyWithToLabels() {
      var maxWidth = 0;
      var labels = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.labels[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var label = _step.value;

          label = _reactDom2['default'].findDOMNode(label);
          labels = [].concat(_toConsumableArray(labels), [label]);
          maxWidth = label.offsetWidth > maxWidth ? label.offsetWidth : maxWidth;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator['return']) {
            _iterator['return']();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = labels[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var label = _step2.value;

          label.style.width = maxWidth + 1 + 'px';
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2['return']) {
            _iterator2['return']();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  }, {
    key: 'applyWithToRows',
    value: function applyWithToRows() {
      var maxWidth = 0;
      var rows = [];

      for (var prop in this.refs) {
        if (this.refs.hasOwnProperty(prop)) {
          var row = _reactDom2['default'].findDOMNode(this.refs[prop]);
          rows = [].concat(_toConsumableArray(rows), [row]);
          maxWidth = row.offsetWidth > maxWidth ? row.offsetWidth : maxWidth;
        }
      }

      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = rows[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var row = _step3.value;

          row.style.width = maxWidth + 'px';
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3['return']) {
            _iterator3['return']();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var onSubmit = _props.onSubmit;
      var children = _props.children;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['onSubmit', 'children', 'style']);

      children = _react.Children.map(children, (function (element, index) {
        var isLast = index + 1 === _react.Children.count(children);
        if (isLast) {
          element = (0, _react.cloneElement)(element, {
            style: (0, _Styling.mergeStyles)({}, element.props.style, { marginBottom: '0' })
          });
        }

        if (element.type === _FormRow2['default']) {
          var ref = 'row-' + index;
          return _react2['default'].createElement(
            _FormRowWrapper2['default'],
            { ref: ref, style: style },
            (0, _react.cloneElement)(element, { form: this })
          );
        } else if (element.type === _Label2['default']) {
          var ref = 'label-' + index;
          return _react2['default'].createElement(
            _FormRowWrapper2['default'],
            { ref: ref, style: this.styles.label },
            (0, _react.cloneElement)(element, { form: this })
          );
        }
        return element;
      }).bind(this));

      return _react2['default'].createElement(
        'form',
        _extends({}, props, { onSubmit: this.submit.bind(this), style: (0, _Styling.applyStyle)(this.styles) }),
        children
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.osx_10_11, this.props.style);
    }
  }]);

  return Form;
})(_react.Component);

exports['default'] = Form;
module.exports = exports['default'];