'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Styling = require('../Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var _Label = require('../Label');

var _Label2 = _interopRequireDefault(_Label);

var _TextField = require('../TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _PushButton = require('../PushButton');

var _PushButton2 = _interopRequireDefault(_PushButton);

var styles = {
  osx_10_11: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    marginBottom: '20px',

    buttonRow: {
      marginTop: '4px'
    }
  }
};

var Row = (function (_Component) {
  _inherits(Row, _Component);

  _createClass(Row, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      form: _react.PropTypes.any,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function Row(props) {
    _classCallCheck(this, Row);

    _get(Object.getPrototypeOf(Row.prototype), 'constructor', this).call(this);
    this.state = { visible: props.visible !== false, display: props.display !== false };
  }

  _createClass(Row, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.form) {
        this.props.form.registerRow(this);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var form = _props.form;
      var display = _props.display;
      var visible = _props.visible;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'form', 'display', 'visible']);

      var isButtonsRow = null;

      children = _react.Children.map(children, (function (element, index) {
        if (element.type === _Label2['default']) {
          isButtonsRow = false;
        } else if (element.type === _TextField2['default']) {
          isButtonsRow = false;
        } else if (element.type === _PushButton2['default'] && isButtonsRow === null) {
          isButtonsRow = true;
        }
        return (0, _react.cloneElement)(element, { form: form, row: this });
      }).bind(this));

      var styles = this.styles;
      if (isButtonsRow) {
        styles = (0, _Styling.mergeStyles)(styles, this.styles.buttonRow);
      }

      if (!this.state.visible) {
        styles = (0, _Styling.mergeStyles)(styles, { visibility: 'hidden' });
      } else {
        styles = (0, _Styling.mergeStyles)(styles, { visibility: 'visible' });
      }

      if (!this.state.display) {
        styles = (0, _Styling.mergeStyles)(styles, { display: 'none' });
      } else {
        styles = (0, _Styling.mergeStyles)(styles, { display: 'flex' });
      }

      return _react2['default'].createElement(
        'div',
        _extends({}, props, { style: (0, _Styling.applyStyle)(styles) }),
        children
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.osx_10_11, this.props.style);
    }
  }]);

  return Row;
})(_react.Component);

exports['default'] = Row;
module.exports = exports['default'];